#!/usr/bin/env python
# -*- coding: utf-8 -*-
# main.py - Ignacio Rodriguez
# Un simple programa para mover al butia! :) #
import gtk
from pybot import usb4butia
from threading import Thread
import gobject
import time
butia = usb4butia.USB4Butia()
botones = []
distancias = []
grises = []
MOLESTANDO_GATOS = False


class utils():
    current = 0


def _know():
    for x in botones:
        botones.remove(x)

    for x in distancias:
        distancias.remove(x)

    for x in grises:
        grises.remove(x)

    for utils.current in range(7):
        if butia.isPresent("button:" + str(utils.current)):
            if not utils.current in botones:
                botones.append(utils.current)

    utils.current = 0

    for utils.current in range(7):
        if butia.isPresent("distanc:" + str(utils.current)):
            if not utils.current in distancias:
                distancias.append(utils.current)
    utils.current = 0

    for utils.current in range(7):
        if butia.isPresent("grey:" + str(utils.current)):
            if not utils.current in grises:
                grises.append(utils.current)
    utils.current = 0

    botones.sort()
    grises.sort()
    distancias.sort()
    return True

_know()


class Programa(gtk.Window):
    def __init__(self):
        super(Programa, self).__init__()
        self.set_size_request(500, 500)
        self.set_title("Simple Butia - Ignacio Rodríguez 2013")
        self.vbox = gtk.VBox()
        self._adelante_btn = gtk.Button("Adelante")
        self._atras_btn = gtk.Button("Atras")
        self._detener_btn = gtk.Button("Detener")
        self.salir = gtk.Button("Salir")
        # Refrescar botones & otras cosas #
        self.refresh = gtk.Button(gtk.STOCK_REFRESH)
        self.refresh.set_use_stock(True)
        self.refresh.connect('clicked', self._make)
        self.gobjects = []
        #
        self._detener_btn.set_sensitive(False)
        self._derecha_btn = gtk.Button("Derecha")
        self._izquierda_btn = gtk.Button("Izquierda")
        self._velocidad_box = gtk.HBox()
        self._bateria_box = gtk.HBox()
        self.current = self._detener_btn
        self._mov_img = gtk.Image()
        self._mov_img.set_from_file("Movimiento.png")
        self._sen_img = gtk.Image()
        self._sen_img.set_from_file("Sensores.png")

        self.vbox.pack_start(self._mov_img, False, False, 0)
        self.vbox.pack_start(self._adelante_btn, False, False, 6)
        self.vbox.pack_start(self._atras_btn, False, False, 6)
        self.vbox.pack_start(self._derecha_btn, False, False, 6)
        self.vbox.pack_start(self._izquierda_btn, False, False, 6)
        self.vbox.pack_start(self._detener_btn, False, False, 6)
        self.vbox.pack_start(self._bateria_box, False, False, 6)
        self.vbox.pack_start(self._velocidad_box, False, False, 6)
        self.vbox.pack_start(gtk.HSeparator(), False, False, 6)
        self.vbox.pack_start(self._sen_img, False, False, 0)
        self.vbox.pack_start(self.refresh, False, False, 6)
        self.vbox.pack_end(self.salir, False, False, 6)
        self.salir.connect('clicked', self._detener, True)
        self._velocidad_box.pack_start(gtk.Label("Velocidad del butia:"),
                    False, False, 6)
        # Botones: #
        self._botones_box = gtk.VBox()
        self.vbox.pack_end(self._botones_box, False, False, 6)
        ##
        self.velocidad = 600

        # Batería
        self._bateria = gtk.ProgressBar()
        self._bateria.set_adjustment(gtk.Adjustment(1, 6, 255, 1))
        self._bateria_label = gtk.Label("Batería del Butia:")
        self._bateria_box.pack_start(self._bateria_label, False, False, 6)
        self._bateria_box.pack_end(self._bateria, True, True, 6)
        ##
        adjustment = gtk.Adjustment(1, 600, 1023, 10)
        self._velocidad_btn = gtk.SpinButton()
        self._velocidad_btn.set_adjustment(adjustment)
        self._velocidad_btn.connect('value-changed', self.set_velocidad)
        self._velocidad_box.pack_end(self._velocidad_btn, True, True, 6)
        ##
        self._adelante_btn.connect('clicked', self._atras)
        self._atras_btn.connect('clicked', self._adelante)
        self._detener_btn.connect('clicked', self._detener)
        self._derecha_btn.connect('clicked', self._derecha)
        self._izquierda_btn.connect('clicked', self._izquierda)
        self.connect('destroy', self._detener)
        self.scroll = gtk.ScrolledWindow()
        self.scroll.set_policy(gtk.POLICY_AUTOMATIC, gtk.POLICY_AUTOMATIC)
        self.port = gtk.Viewport()
        self.port.modify_bg(gtk.STATE_NORMAL, gtk.gdk.color_parse("white"))
        self.port.add(self.vbox)
        self.scroll.add(self.port)
        self.add(self.scroll)
        gobject.timeout_add(1000, self._set_bateria)
        if MOLESTANDO_GATOS:
            self.connect("key-press-event", self._moverse)
        gobject.timeout_add(2000, self._reconocer)
        self.show_all()
        #self._girar_90()

    def _girar_90(self):
        def _gire():
            butia.set2MotorSpeed(0, self.velocidad, 1, self.velocidad)
            time.sleep(2)
            butia.set2MotorSpeed(0, 0, 0, 0)
        Thread(target=_gire).start()

    def _set_bateria(self):
        self._bateria.set_value(butia.getBatteryCharge())
        self._bateria.set_text(str(butia.getBatteryCharge()) + "/255")
        self._bateria.show_all()
        return True

    def _reconocer(self):
        butia.refresh()
        if butia.get_butia_count():
            pass
        else:
            mensaje = gtk.MessageDialog(type=gtk.MESSAGE_WARNING,
                        buttons=gtk.BUTTONS_OK)
            mensaje.set_markup("<b><big>P</big>arece que el robot se ha " +\
            "quitado. Porfavor reinicie el programa...</b>")
            mensaje.set_title("Hubo un error..")
            res = mensaje.run()
            if res == gtk.RESPONSE_OK:
                butia.close()
                exit("Hasta Luego. Ignacio Rodríguez 2013")

        return True

    def _make(self, widget):
        # Botones = 0
        # Distancia = 1
        # Grises (Ldr) = 2
        #
        _know()
        utils.current = 0
        for x in self.gobjects:
            gobject.source_remove(x)

        for x in list(self._botones_box):
            self._botones_box.remove(x)

        for x in botones:
            self.button = gtk.Button("Botón conectado en el puerto " + str(x))
            gc = gobject.timeout_add(250, self._saber, self.button, None, x)
            self.gobjects.append(gc)
            self._botones_box.pack_start(self.button, False, False, 6)

        for x in distancias:
            self.button = gtk.Button("Sensor de distancia conectado " +\
            "en el puerto " + str(x))
            self._botones_box.pack_start(self.button, False, False, 6)
            self.button.connect('clicked', self._distancias, x)

        for x in grises:
            self.button = gtk.Button("Sensor LDR conectado en el puerto " +\
             str(x))
            self._botones_box.pack_start(self.button, False, False, 6)
            self.button.connect('clicked', self._grises, x)

        self.show_all()
        return True

    def _distancias(self, widget, sensor):
        dialogo = gtk.MessageDialog(buttons=gtk.BUTTONS_OK,
                                    type=gtk.MESSAGE_INFO)
        dialogo.set_size_request(400, -1)
        butia.refresh()

        def _set():
            distancia = str(butia.getDistance(sensor))
            dialogo.set_markup("Tipo de sensor: Distancias\n<b>Sensor N°" +\
             str(sensor) + "</b>\nValor: <b>" + distancia + "</b>")
            _set()

        Thread(target=_set).start()
        nf = dialogo.run()
        if nf == gtk.RESPONSE_OK:
            dialogo.destroy()

    def _grises(self, widget, sensor):
        dialogo = gtk.MessageDialog(buttons=gtk.BUTTONS_OK,
                                    type=gtk.MESSAGE_INFO)
        dialogo.set_size_request(300, -1)
        butia.refresh()

        def _set():
            distancia = str(butia.getGray(sensor))
            dialogo.set_markup("Tipo de sensor: LDR\n<b>Sensor N°" +\
             str(sensor) + "</b>\nValor: <b>" + distancia + "</b>")
            _set()
        Thread(target=_set).start()
        nf = dialogo.run()
        if nf == gtk.RESPONSE_OK:
            dialogo.destroy()

    def _moverse(self, widget, event):
        ARRIBA = 65362
        ABAJO = 65364
        DERECHA = 65363
        IZQUIERDA = 65361
        self._detener()
        self._velocidad_btn.set_sensitive(False)
        if event.keyval == ARRIBA:
            self._atras(None)
        elif event.keyval == ABAJO:
            self._adelante(None)
        elif event.keyval == DERECHA:
            self._derecha(None)
        elif event.keyval == IZQUIERDA:
            self._izquierda(None)

    def _saber(self, widget, event, boton):
        if butia.getButton(boton) == 1:
                widget.set_sensitive(True)
                widget.set_label("Botón activo conectado en el puerto " +\
                 str(boton))
        else:
                widget.set_sensitive(False)
                widget.set_label("Botón inactivo conectado en el puerto " +\
                 str(boton))
        return True

    def _adelante(self, widget):

        try:
            self.current.set_sensitive(True)
        except:
            pass
        try:
            widget.set_sensitive(False)
            self.current = widget
        except:
            pass
        butia.set2MotorSpeed(1, self.velocidad, 1, self.velocidad)

    def _derecha(self, widget):
        try:
            self.current.set_sensitive(True)
        except:
            pass
        try:
            widget.set_sensitive(False)
            self.current = widget
        except:
            pass
        butia.set2MotorSpeed(1, self.velocidad, 0, self.velocidad)

    def _izquierda(self, widget):
        try:
            self.current.set_sensitive(True)
        except:
            pass
        try:
            widget.set_sensitive(False)
            self.current = widget
        except:
            pass
        butia.set2MotorSpeed(0, self.velocidad, 1, self.velocidad)

    def _atras(self, widget):
        try:
            self.current.set_sensitive(True)
        except:
            pass
        try:
            widget.set_sensitive(False)
            self.current = widget
        except:
            pass

        butia.set2MotorSpeed(0, self.velocidad, 0, self.velocidad)

    def _detener(self, widget=None, salir=False):
        try:
            self.current.set_sensitive(True)
        except:
            pass
        try:
            widget.set_sensitive(False)
            self.current = widget
        except:
            pass
        butia.set2MotorSpeed(0, 0, 0, 0)
        if salir:
            exit("Gracias por usar esta tontería. Att: Ignacio Rodríguez")

    def set_velocidad(self, widget):
        self.velocidad = int(widget.get_text())
        try:
            self.current.set_sensitive(True)
        except:
            pass
        self.current = self._detener_btn
        self.current.set_sensitive(False)
        butia.set2MotorSpeed(0, 0, 0, 0)

if __name__ == "__main__":
    if butia.get_butia_count():
        Programa()
    else:
        mensaje = gtk.MessageDialog(type=gtk.MESSAGE_WARNING,
                                    buttons=gtk.BUTTONS_OK)
        mensaje.set_markup("<b>No se encontro ningún butia," +\
        " porfavor conecte el robot y vuelva a ejecutar el programa." +\
         " Si usted tiene algun otra instancia abierta de este programa" +\
          " cierre la misma...</b>")
        mensaje.set_title("Ningún Butia detectado")
        res = mensaje.run()
        if res == gtk.RESPONSE_OK:
            butia.close()
            exit("Hasta Luego. Ignacio Rodríguez 2013")
    gtk.main()
